'sNQ-Auswuchtplatz V2.0, Harald Sattler, Februar 2012
'
' ber den Nummernblock werden die Motoren gesteuert, Ein/Aus - Langsamer/Schneller
' Dafr muss ein Terminalprogramm laufen und mit den Werten fr Williams GUI auf deren COM-Port arbeiten
' Geeignet: Free Serial Port Monitor in Verbindung mit der GUI von William (www.serial-port-monitor.com)
' Alternativ: HyperTerm XP.
' HowTo siehe "http://digitizor.com/2009/08/29/install-winxp-hyperterminal-client-on-windows-vista-or-windows-7-free/"
'
' Bedienung:
'   7   8   9       \   S   /    Mot LV e/a   5 schneller   Mot RV e/a
'
'   4   5   6       l   0   s    1 langsamer  alle Mot aus  1 schneller
'
'   1   2   3       /   L   \    Mot LH e/a   5 langsamer   Mot RH e/a
'
'   0                            Stop (Speed 0)
'------------------------------------------------------------------
' 7, 9, 1, 3   schaltet jeweils einen Motor ein/aus
' 5            schaltet alle Motoren aus, Speed bleibt eingestellt
' 8, 9         ndert Speed um 5 Punkte
' 4, 6         ndert Speed um 1 Punkt
' 0            ndert Speed auf 0, alle Motoren werden ausgeschaltet
' wenn min. einer der Motoren luft, werden jede Sek. die ACC-Werte ausgegeben
' a            einmalige Anzeige der ACC-Werte (Aktuell, min, max) ein
' +/-          ndert die Strobo-Frequenz um 1 Wert
' */_          ndert die Strobo-Frequenz um 10 Werte
' f/F          ndert den Faktor der Dmpfung (significant Bits einstellen)
' g/G          ndert den Abstand, den ein Messwert vom Maximum haben muss, um die LED auszulsen
'
' Info:
' f/F und g/G mssen zur Laufzeit passend ausgewhlt werden, so dass bei Stillstand aller Motoren
' die LED nicht (oder nur selten) blitzt und bei Lauf eines Motors immer nur einmal je Umdrehung
' Die Werte mssen nach jedem Programmstart experimentell ermittelt werden und werden nicht gespeichert. 
'--------------------------------------------------------------------------------

'$prog lock &HFF , Ext &HFF , Hi &HDA , Lo &HF7                             ' Fuses fr den Atmel
' Meine Werte aus myAVR ProgTool:
' geballt: Low Fuse: 0xF7 | High Fuse: 0xD2 | Extended Fuse: 0xFF | Lockbits: 0xFF
' aufgedrselt:
' LF 0xF7: Ext. Full-swing Crystal, Start-Up time PWRDWN/RESET: 16K CK/14 CK + 65 ms
' HF 0xD2: Serial program download (SPI) enabled, Preserve EEPROM through Chip Erase
' EF 0xFF: Brownout detection disabled
' LB 0xFF: No protection at all

'===CHIP SETTINGS===
$regfile = "m328pdef.dat"
$framesize = 64
$swstack = 64
$hwstack = 64
$crystal = 16000000
$baud = 38400
$lib "I2C_TWI.Lbx"                                          ' Hardware-IC verwendet fr IMU-Werte auslesen

Declare Sub Init_mpu ;                                      ' Sensor Initialisieren
Declare Sub Read_mpu                                        ' Sensor auslesen
Declare Sub Control                                         ' Stellwerte vom Rechner
Declare Sub Upmval_mathe                                    ' Berechnung der verschiedenen Umdrehungsvariablen

Config Timer0 = Timer , Prescale = 1024 , Clear_timer = 1 , Compare_a = Disconnect
Compare0a = 250                                             ' erzeugt einen 16 ms Interrupt
On Compare0a Counter_irq

Config Timer1 = Timer , Prescale = 1 , Clear_timer = 1 , Compare_a = Disconnect       ' Timer1 erzeugt die PPM-Impulse fr die 4 ESCs
Compare1a = 16000                                           ' Startwert 1,01 ms
On Compare1a Esc_irq

Config Timer2 = Timer , Prescale = 64 , Compare_a = Disconnect , Clear_timer = 1       ' Timer2 erzeugt ein Stroboskop fr die Drehzahlermittlung der Motoren
Compare2a = 25                                              ' ergibt mit Prescale = 64 einen 100s-Takt
On Compare2a Upm_irq

'===SERIAL IN SETTINGS===
Config Serialout = Buffered , Size = 254
Config Serialin = Buffered , Size = 254

'===PORT SETTINGS===
' IMU-Kommunikation
Config Scl = Portc.5                                        'for IMU
Config Sda = Portc.4                                        'for IMU
Config Twi = 400000                                         ' IC clock speed 400 kHz
' TWI gleich einschalten, das macht Bascom ansonsten erst beim I2CStart !
Twcr = &B00000100                                           ' nur TWEN setzen

' Motoren (PWM)
Config Portd.6 = Output                                     'Mot RH - Esc_id(1)
Config Portb.3 = Output                                     'Mot RV - Esc_id(2)
Config Portd.5 = Output                                     'Mot LH - Esc_id(3)
Config Portd.3 = Output                                     'Mot LV - Esc_id(4)

' LEDs
Config Portd.7 = Output                                     'led 1 (Willa-LED) ROT
Config Portb.0 = Output                                     'led 2 (Willa-LED) BLAU
Config Portb.1 = Output                                     'led 3 (Willa-LED) GELB

Config Portc.2 = Output                                     'LED 1 Positionslichter vorne (Blau/Wei)
Config Portc.3 = Output                                     'LED 2 Positionslichter hinten (Rot)

Config Portb.4 = Output                                     ' Rechteck auf MISO-Pad fr IRQ-Laufzeit-Messung
Config Portb.5 = Output                                     ' Rechteck auf SCK-Pad fr Schleifendurchlauf-Messung
Config Portd.4 = Output                                     ' Rechteck auf Res-Pad fr Schleifendurchlauf-Messung
Config Portb.2 = Output                                     ' Rechteck auf Rec_-Pad fr Schleifendurchlauf-Messung

Config Portd.2 = Output                                     ' Ausgang fr Strobo-LED, mit R Strom begrenzen!


'--Alias's
Led_1 Alias Portd.7
Ledblau Alias Portd.7
Led_2 Alias Portb.0
Ledrot Alias Portb.0
Led_3 Alias Portb.1
Ledgelb Alias Portb.1                                       ' B.1 = gelbe LED (fr Debug ohne externe LED)
Strobo Alias Portd.2                                        ' D.2 = REC-Eingang (steckbar fr Strobo-LED)

Reset Ledblau
Reset Ledgelb
Reset Ledrot


Portd.6 = 0                                                 ' PWM-Asugnge AUS
Portb.3 = 0
Portd.5 = 0
Portd.3 = 0

Dim S1 As Byte
Dim I As Word
Dim A1 As Word , A2 As Word , B As Byte

'--ESCs--
Dim Esc_id As Byte
Dim Esc_puls(4) As Word                                     ' 4 ESCs werden angesteuert
Dim Esc_p As Word
Dim Comm_val(4) As Byte
Dim Temp_val As Word

'--MPU--
Const Mpuaddr = &HD3                                        ' Device adr. = 69H (as 7bit adr), Read adr = D3 (LSB = 1)
Const Mpuaddw = &HD2                                        ' Device adr. = 69H (as 7bit adr), write adr = D2  (LSB = 0)
Dim Test As Byte
Dim Get_accx As Integer
Dim Get_accy As Integer
Dim Get_accz As Integer
Dim Meas_accx(2) As Byte At Get_accx Overlay
Dim Meas_accy(2) As Byte At Get_accy Overlay
Dim Meas_accz(2) As Byte At Get_accz Overlay

'--GUI Connection--
Dim A As String * 8
Dim Addi As String * 8
Dim Sensory(10) As Word
Dim Sensormax As Word
Dim Sensormin As Word
Dim Sensordiff As Word
Dim Sensorband As Word
Dim Sensormean As Word
Dim Sensoroff As Word

Dim Printy As Bit                                           ' Ausgabe der Y-ACC-Werte

Dim Gotreset As Byte                                        ' notwendig, damit Willas GUI funkioniert
Dim Gotread As Byte                                         '
Dim Gotsensors As Byte                                      '
Dim Gotinput As Byte                                        '
Dim Var(33) As Byte                                         '
Dim Sensor(13) As Byte                                      ' notwendig, damit Willas GUI funkioniert

For A1 = 0 To 33                                            ' Array mit Irgendwas fllen, wird nie abgespeichert
   Var(a1) = 100
Next A1

Dim Yfaktor As Byte                                         ' Faktoren und Zeug fr die Y-ACC-Auswertung
Dim Yshift As Byte
Dim Yoffset As Word

Yfaktor = 1

Dim Strobe As Bit
Strobe = 0                                                  ' Strobe = 0 bedeutet Auswuchten (LED wird von Unwucht gesteuert)
                                                             ' Strobe = 1 bedeutet Stroboskop (LED wird von Timer gesteuert)
Dim Upmval As Word                                          ' "Drehzahl" fr Strobo-LED
Dim Upmval1 As Single
Dim Upmval2 As Single
Dim Strobocount As Word

Dim Drehzahl As Single                                      ' echte Drehzahl in Umdrehungen / min (=Upmval / 60)
Dim Upm As Word

Upmval1 = 1361                                              ' Strobo starten mit 440 upm
Upmval_mathe                                                ' Berechnung der verschiedenen Umdrehungsvariablen

Dim Speed As Byte                                           ' Drehzahlvorgabe 0..255
Dim Motor As Byte                                           ' Motornummer: 1 = lh, 3 = rh, 7 = lv, 9 = rv
Dim Speedchanged As Byte

Dim Counterval As Byte                                      ' Zhler fr Sekunden-Raster (fr alles Mgliche)
Counterval = 0

Esc_puls(1) = 16000                                         ' alle ESCs auf Aus (1,01 ms)
Esc_puls(2) = 16000
Esc_puls(3) = 16000
Esc_puls(4) = 16000

Comm_val(1) = 0
Comm_val(2) = 0
Comm_val(3) = 0
Comm_val(4) = 0



'===============================================================================
Esc_id = 1                                                  ' mit 1. ESC staren

Speed = 0                                                   ' Soll-Drehzahl Stopp
Speedchanged = 0                                            ' = 1: Drehzahl wurde verndert -> Motorwerte neu schreiben


Set Ledgelb
Waitms 500                                                  ' Zeit fr die ESCs zu booten
Reset Ledgelb

Enable Compare0a                                            'required in any case
Enable Compare1a                                            'required in any case
Enable Compare2a
Enable Interrupts                                           'required in any case


'===============================================================================
Init_mpu                                                    ' Sensor initialisieren

A1 = 1                                                      ' Laufvariable fr Messwerte-Array zur Mini-/Maximum-Bestimmung
A2 = 0                                                      ' Laufvariable fr "zeit"gesteuertes Verkleinern der Min/Max-Werte
Sensormax = 8408                                            ' beide Extremwerte mit Mittelwert vorbelegen
Sensormin = 8408

Dim Sensorgap As Byte
Sensorgap = 3

'==Hauptschleife=================================
Do

   Toggle Portb.2                                           ' Bestimmung der Schleifenzeit per Oszi
If Strobe = 0 Then                                          ' LED wird vom Sensor gesteuert, Auswucht-Modus

   Read_mpu                                                 ' ACC Y-Werte auslesen
   Set Portd.4                                              ' Laufzeitbestimmung zwischen Sensor lesen und LED-Blitz

   ' die ACC-Werte gehen von ca. -8408 .. +8408 und rauschen sehr stark (+-200 Punkte)
   ' deshalb skalieren

   Yshift = Yfaktor - 1
   Shift Get_accy , Right , Yshift , Signed                 ' auf n bit schrumpfen, einstellbar ber die Komm-SS mit f/F
   Yoffset = 8400 / Yfaktor
   Get_accy = Get_accy + Yoffset                            ' wir verarbeiten nur positive Werte

   If Get_accy < Sensormin Then Sensormin = Get_accy        ' Maxima und Minima ermitteln und abspeichern
   If Get_accy > Sensormax Then Sensormax = Get_accy

   Sensorband = Sensormax - Sensorgap                       ' Strobo soll blitzen, wenn der aktuelle Wert in der Nhe von Maximum ist
                                                            ' Gap einstellbar ber die Komm-SS mit g/G
   If Get_accy > Sensorband Then
      Reset Portd.4                                         ' Laufzeitbestimmung zwischen Sensor lesen und LED-Blitz
      Set Strobo                                            ' LED blitzen lassen
      Waitus 5                                              ' die LED muss eine gewisse Zeit an sein, damit der Blitz zu sehen ist
      Reset Strobo
   End If

   Incr A2

   If A2 > 600 Then                                         ' nach einer Zeit den MAX-Wert wieder kleiner machen
      Sensordiff = Sensormax - Sensormin
      Sensordiff = Sensordiff / 16                          ' Schrittweite und Intervall...
      Sensormin = Sensormin + Sensordiff                    ' ... willkrlich festgelegt, kein Plan, was sinnvoller wre...
      Sensormax = Sensormax - Sensordiff
      A2 = 0
   End If

Else                                                        ' Strobe = 1 -> LED wird vom Timer gesteuert, Drehzahl-Modus

   If Strobocount > Upmval Then                             ' Strobocount wird im IRQ hochgezhlt
      Strobocount = 0                                       ' neue Runde

      Set Strobo                                            ' LED blitzen lassen
      Waitus 5                                              ' die LED muss eine gewisse Zeit an sein, damit der Blitz zu sehen ist
      Reset Strobo
    End If

End If

   If Counterval > 63 Then
      Counterval = 0
      If Comm_val(1) > 0 Or Comm_val(2) > 0 Or Comm_val(3) > 0 Or Comm_val(4) > 0 Then
         Printy = 1                                         ' ca. jede Sekunde einmal die Sensorwerte ausgeben
      End If
   End If

   If Printy = 1 Then
      Sensormean = Sensormax + Sensormin
      Sensormean = Sensormean / 2
      Sensoroff = Sensormax - Sensormean
      Print " Ay: " ; Get_accy ; " Min: " ; Sensormin ; " Max: " ; Sensormax ; " Mittelwert: " ; Sensormean ; " Abweichung: " ; Sensoroff
      Printy = 0                                            ' immer nur eine einzelne Zeile ausgeben
   End If

   Control                                                  ' Kommunikation mit Rechner/GUI

   Reset Portd.4                                            ' wenn kein Maximum in diesem Durchlauf erreicht wurde,
                                                             ' Port dennoch rckssetzen fr die nchste Messung

Loop
'================================================

End


'---IRQ-Routinen----------------------------------------------------------------
' Erzeugung der PPM-Impulse fr vier ESCs

'Config Portd.6    'Mot RH - Esc_id(1)      Zuordnung zwischen PORT, Motor und Steuer-Variable
'Config Portb.3    'Mot RV - Esc_id(2)
'Config Portd.5    'Mot LH - Esc_id(3)
'Config Portd.3    'Mot LV - Esc_id(4)

Esc_irq:
Toggle Portb.4                                              ' Laufzeit der IRQ-Routine

Select Case Esc_id                                          ' in jedem Schleifendurchlauf wird ein anderer ESC angesprochen
   Case 1 : Portd.6 = 0                                     ' hier wird der vorhergehende ESC-Impuls abgeschaltet
   Case 2 : Portb.3 = 0
   Case 3 : Portd.5 = 0
   Case 4 : Portd.3 = 0
   Case Else :
End Select

Incr Esc_id
If Esc_id > 4 Then
   Esc_id = 1
End If

Select Case Esc_id
   Case 1 : Portd.6 = 1                                     ' hier wird der aktuelle ESC-Impuls eingeschaltet
   Case 2 : Portb.3 = 1
   Case 3 : Portd.5 = 1
   Case 4 : Portd.3 = 1
   Case Else :
End Select

Compare1a = Esc_puls(esc_id)                                ' Impuls-Start fr nchsten ESC

'Toggle Portb.4                                              ' Laufzeit der IRQ-Routine

Return

'-------------------------------------------------------------------------------
' Erzeugt ein Strobo fr Drehzahlbestimmung des Motors
Upm_irq:

   Incr Strobocount

Return

'-------------------------------------------------------------------------------
' Erzeugt einen 16 ms Clock fr alles Mgliche
Counter_irq:

   Incr Counterval

Return


'===============================================================================


'===MPU-6050 Config=============================================================
Sub Init_mpu

  I2cstart                                                  'start condition
  I2cwbyte Mpuaddw                                          'write adress of MPU-6050
  I2cwbyte 117                                              'Register 117 "Who am I"
  I2cstart                                                  'repeated start
  I2cwbyte Mpuaddr                                          'read adress of MPU-6050
  I2crbyte Test , Nack                                      'read byte WHO_AM_I (Reg 117)
  I2cstop                                                   'stop condition
  Print "MPU-6050 Initalisierung"
  Print "'Who am I'-Register - Soll 104 - Ist: " ; Test
  Print "Error: " ; Err
  Print

'Auswuchten = 1 -> Alle Sensoren auf volle Empfindlichkeit, keine Dmpfung, 8 kHz Abtastrate
  I2cstart                                                  'start condition
  I2cwbyte Mpuaddw                                          'write adress of MPU-6050
  I2cwbyte 25                                               'Register 25 Sample Rate Divider (1..8 kHz)
  'I2cwbyte &B00000111                                       'Divider set to 8
  I2cwbyte &B00000000                                       'Divider set to 1   (soll)
  I2cstop                                                   'stop condition

  I2cstart                                                  'start condition
  I2cwbyte Mpuaddw                                          'write adress of MPU-6050
  I2cwbyte 26                                               'Register 26 DLPF_CFG (digital lowpass filter) Configuration
  I2cwbyte &B00000000                                       'Bits 0..2 = 000 - ACC:260Hz, 0.0ms; Gyro:256Hz, 0.98ms
'  I2cwbyte &B00000001                                       'Bits 0..2 = 001 - ACC:184Hz, 2.0ms; Gyro:188Hz, 1.9ms
'  I2cwbyte &B00000010                                       'Bits 0..2 = 010 - ACC: 94Hz, 3.0ms; Gyro: 98Hz, 2.8ms
'  I2cwbyte &B00000011                                       'Bits 0..2 = 011 - ACC: 44Hz, 4.9ms; Gyro: 42Hz, 4.8ms
'  I2cwbyte &B00000100                                       'Bits 0..2 = 100 - ACC: 21Hz, 8.5ms; Gyro: 20Hz, 8.3ms
'  I2cwbyte &B00000101                                       'Bits 0..2 = 101 - ACC: 10Hz,13.8ms; Gyro: 10Hz, 13.4ms
'  I2cwbyte &B00000110                                       'Bits 0..2 = 110 - ACC:  5Hz,19.0ms; Gyro:  5Hz, 18.6ms
  I2cstop                                                   'stop condition

  I2cstart                                                  'start condition
  I2cwbyte Mpuaddw                                          'write adress of MPU-6050
  I2cwbyte 27                                               'Register 27 Gyro Configuration
'  I2cwbyte &B00011000                                       'Bits 3+4 = 11 - Full Scale Range: +/-2000/s
'  I2cwbyte &B00010000                                       'Bits 3+4 = 10 - Full Scale Range: +/-1000/s
  'I2cwbyte &B00001000                                       'Bits 3+4 = 01 - Full Scale Range: +/-500/s
  I2cwbyte &B00000000                                       'Bits 3+4 = 00 - Full Scale Range: +/-250/s
  I2cstop                                                   'stop condition

  I2cstart                                                  'start condition
  I2cwbyte Mpuaddw                                          'write adress of MPU-6050
  I2cwbyte 28                                               'Register 28 ACC Configuration
  'I2cwbyte &B00011000                                       'Bits 3+4 = 11 - Full Scale Range: +/-16g / No High Pass Filter
  'I2cwbyte &B00010000                                       'Bits 3+4 = 10 - Full Scale Range: +/-8g / No High Pass Filter
  'I2cwbyte &B00001000                                       'Bits 3+4 = 01 - Full Scale Range: +/-4g / No High Pass Filter
  I2cwbyte &B00000000                                       'Bits 3+4 = 00 - Full Scale Range: +/-2g / No High Pass Filter
  I2cstop                                                   'stop condition

  I2cstart                                                  'start condition
  I2cwbyte Mpuaddw                                          'write adress of MPU-6050
  I2cwbyte 107                                              'Register 107 Power Management 1
  I2cwbyte &B00001011                                       'No Reset / No Sleep / No Cycle / Temp_Sens: Dis / Clock Source: Z-Gyro
  I2cstop
End Sub


'===Read MPU-6050===============================================================
Sub Read_mpu
'==Read only 1 really used ACC-Axis from MPU-60x0==
  I2cstart                                                  'start condition
  I2cwbyte Mpuaddw                                          'write adress of MPU-6050
  I2cwbyte 59                                               'Register 59 ACCEL_XOUT_H
  I2cstart                                                  'repeated start
  I2cwbyte Mpuaddr                                          'read adress of MPU-6050
  I2crbyte Meas_accy(2) , Ack                               'read byte ACCEL_XOUT_H (Reg 59)
  I2crbyte Meas_accy(1) , Nack                              'read byte ACCEL_XOUT_L (Reg 60)
  I2cstop                                                   'stop condition

End Sub

'===/Read MPU-6050===============================================================

'===Control======================================================================
Const Changer = 5
Const Hichanger = 255 - Changer

Sub Control                                                 'RS232 link to the computer
' mit den beiden Ischarwaiting() trenne ich die KommandoStrings aus Willas GUI von meinen SingleChar-Auftrgen
 If Ischarwaiting() > 0 Then
'   Set Ledblau                                              ' for Debug
'   Toggle Ledgelb                                           ' for Debug
   A = Waitkey()                                            ' in Stringavriable einlesen
   Waitms 10                                                ' kurze Pause, sonst kommt der nchste Buchstabe erst in der nchsten Runde

   If Ischarwaiting() > 0 Then
      Waitms 10                                             ' auch hier Bearbeitung verzgern, die Schnittstelle ist zu langsam
      Input Addi Noecho
      A = A + Addi                                          ' hier enthlt A den String von Willas GUI, falls die was geschickt hat
'      Toggle Ledrot                                         ' for Debug
   End If

   Gotreset = Instr(a , "reset!")                           ' Auswertung wie in Willas Originalcode
   Gotread = Instr(a , "cr!")
   Gotsensors = Instr(a , "cs!")
   Gotinput = Instr(a , "ci!")

' Hat die GUI gesprochen, sind wir hier fertig und berspringen die Auswertung der SingleChar-Auftrge
   If Gotreset = 0 And Gotread = 0 And Gotsensors = 0 And Gotinput = 0 Then       ' Einzelzeichen auswerten nur, wenn keine GUI Komm stattfand
'      Toggle Ledblau                                        ' for Debug
      ' hier kommen wir nur an, wenn die GUI nicht dazwischen gefunkt hat und ein einzelnes Zeichen ber die Schnitte kam
      Select Case A                                         ' A (String) enthlt hier ein einzelnes Zeichen
         Case "a" : Toggle Printy                           ' Ausgabe der Y-ACC-Werte ein/aus schalten
         Case "f" :                                         ' f/F wie Faktor
            If Yfaktor > 1 Then
               Yfaktor = Yfaktor / 2                        ' Messwerte des Y-ACC Sensors dmpfen (significant Bits dazu nehmen)
               Print "Faktor " ; Yfaktor
            End If
         Case "F" :                                         ' f/F wie Faktor
            If Yfaktor <= 127 Then
               Yfaktor = Yfaktor * 2                        ' Messwerte des Y-ACC Sensors dmpfen (significant Bits streichen)
               Print "Faktor " ; Yfaktor
            End If
         Case "g" :                                         ' g/G wie Gap/Abstand
            If Sensorgap > 1 Then
               Sensorgap = Sensorgap - 1                    ' Empfindlichkeit des Y-ACC Sensors einstellen, Schwellwert
               Print "Gap " ; Sensorgap
            End If
         Case "G" :                                         ' g/G wie Gap/Abstand
            If Sensorgap <= 9 Then
               Sensorgap = Sensorgap + 1                    ' Empfindlichkeit des Y-ACC Sensors einstellen, Schwellwert
               Print "Gap " ; Sensorgap
            End If
         Case "s" :
            Toggle Strobe                                   ' s schaltet zwischen Strobo- und Wucht-Modus um
            Print "Upmval1 " ; Upmval1 ; "Upmval2 " ; Upmval2 ; "Upmval " ; Upmval ; " Drehzahl: " ; Upm
         Case "+" :
            If Upmval1 < 2000 Then                          ' 2000 ergibt x Upm
               Upmval1 = Upmval1 + 1                        ' Drehzahl erhhen
               Upmval_mathe                                 ' Berechnung der verschiedenen Umdrehungsvariablen
               Print "Upmval " ; Upmval ; " Drehzahl: " ; Upm
            End If
         Case "-" :
            If Upmval > 10 Then
               Upmval1 = Upmval1 - 1                        ' Drehzahl erniedrigen
               Upmval_mathe                                 ' Berechnung der verschiedenen Umdrehungsvariablen
               Print "Upmval " ; Upmval ; " Drehzahl: " ; Upm
            End If
         Case "*" :
            If Upmval1 < 1990 Then                          ' 2000 ergibt x Upm
               Upmval1 = Upmval1 + 10                       ' Drehzahl erhhen
               Upmval_mathe                                 ' Berechnung der verschiedenen Umdrehungsvariablen
               Print "Upmval " ; Upmval ; " Drehzahl: " ; Upm
            End If
         Case "_" :
            If Upmval > 20 Then
               Upmval1 = Upmval1 - 10                       ' Drehzahl erniedrigen
               Upmval_mathe                                 ' Berechnung der verschiedenen Umdrehungsvariablen
               Print "Upmval " ; Upmval ; " Drehzahl: " ; Upm
            End If
         ' ---------------------------------------------------------------------
         Case Else

            'Config Portd.6    'Mot RH - Esc_id(1)      Zuordnung zwischen PORT, Motor und Steuer-Variable
            'Config Portb.3    'Mot RV - Esc_id(2)
            'Config Portd.5    'Mot LH - Esc_id(3)
            'Config Portd.3    'Mot LV - Esc_id(4)

            ' kein Buchstabe, sondern eine Zahl kam an
            B = Val(a)                                      ' String in Zahl umwandeln
            Select Case B
               Case 0 : Speed = 0                           ' Geschwindigkeit 0
                        Speedchanged = 1
               Case 1 : If Comm_val(3) > 0 Then Comm_val(3) = 0 Else Comm_val(3) = Speed       ' Motor LH an/aus
               Case 2 : If Speed >= Changer Then
                           Speed = Speed - Changer
                           Speedchanged = 1                 ' langsamer
                         End If
               Case 3 : If Comm_val(1) > 0 Then Comm_val(1) = 0 Else Comm_val(1) = Speed       ' Motor RH an/aus
               Case 4 : If Speed > 0 Then Speed = Speed - 1 ' Feinverstellung
                           Speedchanged = 1
               Case 5 : Comm_val(1) = 0                     ' alle Motoren STOP
                        Comm_val(2) = 0
                        Comm_val(3) = 0
                        Comm_val(4) = 0
               Case 6 : If Speed < 255 Then Speed = Speed + 1       ' Feinverstellung
                           Speedchanged = 1
               Case 7 : If Comm_val(4) > 0 Then Comm_val(4) = 0 Else Comm_val(4) = Speed       ' Motor LV an/aus
               Case 8 : If Speed < Hichanger Then
                           Speed = Speed + Changer          ' schneller
                           Speedchanged = 1
                         End If
               Case 9 : If Comm_val(2) > 0 Then Comm_val(2) = 0 Else Comm_val(2) = Speed       ' Motor RV an/aus
               Case Else:
            End Select
      End Select

         If Speedchanged = 1 Then
            Speedchanged = 0
            If Comm_val(1) > 0 Then Comm_val(1) = Speed
            If Comm_val(2) > 0 Then Comm_val(2) = Speed
            If Comm_val(3) > 0 Then Comm_val(3) = Speed
            If Comm_val(4) > 0 Then Comm_val(4) = Speed
         End If

         Temp_val = Comm_val(1) * 63                        ' ergibt die Lnge des PWM-Impulses
         Temp_val = Temp_val + 16000                        ' dazu gerechnet die 1,01 ms fr Nullstellung
         Esc_puls(1) = Temp_val

         Temp_val = Comm_val(2) * 63
         Temp_val = Temp_val + 16000
         Esc_puls(2) = Temp_val

         Temp_val = Comm_val(3) * 63
         Temp_val = Temp_val + 16000
         Esc_puls(3) = Temp_val

         Temp_val = Comm_val(4) * 63
         Temp_val = Temp_val + 16000
         Esc_puls(4) = Temp_val

'         If Speedchanged = 1 Then                           ' for Debug
'            Speedchanged = 0                                ' Speedchanged = 0 ca. 20 Zeilen weiter oben auskommentieren
'            Print "Esc_puls(1)=" ; Esc_puls(1) ; " Esc_puls(2)=" ; Esc_puls(2) ; " Esc_puls(3)=" ; Esc_puls(3) ; " Esc_puls(4)=" ; Esc_puls(4)
'         End If

'         Reset Ledblau
    End If

   If Gotreset = 1 Then
      Gotreset = 0
      Waitms 100                                            ' Reset aufrufen
      Goto $3c00                                            '$3c00 -> m328p; $1c00 -> m168
   End If

' Die nachfolgenden Routinen tun im Auswuchtprogramm nichts, mssen aber auf die GUI-Auftrge reagieren,
' damit Willas GUI zufrieden ist und die Flashroutine verwendet werden kann, ohne den Resetschalter zu bemhen

   If Gotread = 1 Then
'      Toggle Ledgelb                                         ' for Debug
      Gotread = 0
      Waitms 25
      Print "s#p!"                                          'tell pc that data will follow
      Printbin Var(1) ; 33                                  'print the list of parameters that can be modified
   End If

   If Gotsensors = 1 Then
'      Toggle Ledrot                                          ' for Debug
      Gotsensors = 0
      Print "ss!"                                           'tell pc that sensor data will follow
      Printbin Sensor(1) ; 13
   End If

   If Gotinput = 1 Then                                     'pc wants to transfer parameters
      Gotinput = 0
      Inputbin Var(1) , 33                                  'read list of parameters
   End If
 End If

End Sub
'===/GUI========================================================================

' Berechnung der verschiedenen Umdrehungsvariablen
Sub Upmval_mathe:

   Upmval2 = 2000 - Upmval1                                    ' minimal 300 Upm = 2000 als Timerwert
   Upmval = Upmval2                                            ' der Timerwert muss kleiner sein fr hhere Drehzahl (2000 - x)
   Upmval2 = Upmval2 / 10
   Drehzahl = 1000 / Upmval2                                   ' Drehzahl in U/s
   Drehzahl = Drehzahl * 60                                    ' ergibt die Drehzahl in U/m als Float
   Upm = Drehzahl                                              ' Umwandlung in WORD fr Anzeige

End Sub
'-------------------------------------------------------------------------------